﻿Type=StaticCode
Version=3
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

   Dim dURL As String ,Title As String ,FileLoaded As String ,BaseHref As String 
   
   Type HTMLvalue(Key As String, Value As String)
   Type HTMLtag(Level As Int, TagName As String, Node As String, Values As List)
End Sub

Sub ParseHTML(HTMLCode As String, URL As String)As String 
   Dim temp As Int, temp2 As Int, htag As String, tempstr As StringBuilder,Name As String, temp3 As String, Node As String ', BaseHREF
   'tempstr="THIS IS A TEST OF THE LCARS WEB SYSTEM"
   Title=""
   BaseHref=""
   tempstr.Initialize 
   
   
   Do Until temp >= HTMLCode.Length OR temp<0
      Log(temp & "/" & HTMLCode.Length)
      If Mid(HTMLCode, temp,1) = "<" Then
         temp2=HTMLCode.IndexOf2(">", temp+1)
         htag=Mid(HTMLCode, temp,temp2-temp+1)
         temp=temp2+1
         
         Log("HTML: " & htag)
         Log("TAG: " & GetTagName(htag))
         
         Name=GetTagName(htag)
         Select Case Name.ToLowerCase 
            Case "a", "script", "title", "h1", "h2", "h3", "header","footer","style"
               'If Not( name.EqualsIgnoreCase("a") AND htag.Contains(" name=") ) Then
                  temp3 = HTMLCode.IndexOf2("</" & Name, temp2)
                  Node=Mid(HTMLCode, temp2+1,temp3-temp2-1).Replace("&quot;", "'").Trim 
                  temp2=HTMLCode.IndexOf2(">", temp3+1)
                  temp=temp2+1
                  Log("NODE2:" & Node)
               'End If
         End Select
         
         Select Case Name.ToLowerCase.Replace("/", "")
            Case "base": BaseHref=htag
            Case "title":    Title= Node
            Case "img"
               'removed broken images
               tempstr.Append(CRLF & htag.Replace("<img", "<img onerror=" & Chr(34) & "this.style.display='none'" & Chr(34) ) )
            Case "h1", "h2", "h3", "h4"
               'tempstr= tempstr & htag & node & "</" & name & ">"
               tempstr.Append(CRLF & htag & Node & "</" & Name & ">")
            Case "a"':      tempstr= tempstr & MakeLCARbutton(lcar.LCAR_Orange, node)
               If Node.Length>0 Then
                  If Not (Node.ToLowerCase.Contains("img")) Then Node=Node.ToUpperCase 
'                  Node=MakeLCARbutton(lcar.LCAR_Orange, htag & Node & "</A>")
'THIS IS THE PART THAT HANDLES URL, CHANGE THIS PART HERE TO SUIT YOUR NEEDS

               End If
'               Node=Node.Replace(" href=" & Chr(34) & "#", " href=" & Chr(34) & ScrollTo(0) & "#")
               'tempstr= tempstr & node
               tempstr.Append(CRLF & Node)
            Case "meta", "link", "!--", "script", "style", "body", "div", "span", "nav" , "input", "form", "ul", "li", "header","section","footer"  'ignore these tags
            Case Else
               'tempstr = tempstr & htag 
               tempstr.Append(CRLF & htag)
         End Select
         
      Else
         temp2=HTMLCode.IndexOf2("<", temp+1)
         If temp2>-1 Then
            htag=Mid(HTMLCode, temp,temp2-temp).Trim
         Else
            temp2=HTMLCode.Length 
            htag=Right(HTMLCode, temp2-temp).Trim 
         End If
         temp=temp2
         Select Case htag
            Case CRLF, "" 
            Case Else 
               'Log("NODE: " & htag)
               If CountAlphaNumericCharacters(htag) >0 Then 'tempstr=tempstr & CRLF & htag.Replace("•", "-")
                  tempstr.Append(CRLF & htag.Replace("•", "-"))
               End If
         End Select
      End If
      
   Loop
   
   If BaseHref.Length=0 Then
      BaseHref=Left(URL, URL.LastIndexOf("/")+1)
      Node="<BASE HREF='" & BaseHref & "'>"
   Else
      Msgbox("EMERGENCY","EMERGENCY")
   End If
   Return Node & tempstr.ToString 
   'htmlcode.IndexOf2(
End Sub


Sub GetTagName(content As String) As String
    Dim temp As Long, temp2 As Long
    temp = Instr(content, " ",0)
    temp2 = Instr(content, ">",0)
    If temp > 0 AND temp < temp2 Then temp2 = temp
    Return Mid(content, 1, temp2 - 1)
End Sub

Sub CountAlphaNumericCharacters(Text As String)As Int
   Dim temp As Int, Count As Int,Character As Int 
   For temp = 0 To Text.Length-1
      Character=Asc(Mid(Text,temp,1).ToLowerCase )
      If ( Character >= Asc("a") AND Character <= Asc("z") ) OR ( Character >= Asc("0") AND Character <= Asc("9")) Then Count=Count+1
   Next
   Return Count
End Sub

Sub Instr(Text As String, TextToFind As String, Start As Int) As Int
   Return Text.IndexOf2(TextToFind,Start)
End Sub

Sub Left(Text As String, Length As Long)As String 
   If Length>Text.Length Then Length=Text.Length 
   Return Text.SubString2(0, Length)
End Sub

Sub Right(Text As String, Length As Long) As String
   If Length>Text.Length Then Length=Text.Length 
   Return Text.SubString(Text.Length-Length)
End Sub

Sub Mid(Text As String, Start As Int, Length As Int) As String 
   If Length>0 AND Start>-1 AND Start< Text.Length Then Return Text.SubString2(Start,Start+Length)
End Sub
